'
' Demonstrate a USB generic HID interface using the Proton BASIC language
'
' The demonstration is configured to use a 12MHz crystal
' This can be changed by altering the fuse setting located in the USB_Defs.inc file
'
    Device = 18F14K50
    'Device = 18F4550
    'Device = 18F87J50

    Declare Xtal = 48
Declare Reminders = Off

    Declare Optimiser_Level = 3             ' Maximum optimisation
    Declare Dead_Code_Remove = On           ' Squeeze the code further

    Declare Hserial_Baud = 57600			' Set baud rate
	Declare Hserial_RCSTA = %10010000       ' Enable serial port and continuous receive
	Declare Hserial_TXSTA = %00100000       ' Enable transmit and asynchronous mode
	Declare Hserial_Clear = On				' Enable Error clearing on received characters

    Dim Buffer As String * 20
    Dim bAmount As Byte
'
'--------------------------------------------------------------------------
    Include "HID_Descriptor.inc"            ' Load the USB routines and descriptor into the program
'--------------------------------------------------------------------------

Main:

    While 1 = 1                                 ' Create an infinite loop
        If tUSB_Attached = True Then            ' Is the USB attached?
            If HID_DataAvailable() = True Then  ' Yes. So is there any USB data for us?
                HID_ReadReport()                ' Yes. So receive it
                HRSOut RXReport                 ' Transmit the data received to the serial terminal
                TXReport = RXReport             ' Transfer RX buffer to TX buffer
                HID_WriteReport()               ' Echo back the data received
            EndIf
        EndIf
    Wend



